POJ2886 Who Gets the Most Candies?【线段树 点修改】

2024-01-20 14:38

本文主要是介绍POJ2886 Who Gets the Most Candies?【线段树 点修改】,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

Who Gets the Most Candies?

http://poj.org/problem?id=2886

Time Limit: 5000MS Memory Limit: 131072K
Total Submissions: 16835 Accepted: 5298
Case Time Limit: 2000MS

Description

N children are sitting in a circle to play a game.

The children are numbered from 1 to N in clockwise order. Each of them has a card with a non-zero integer on it in his/her hand. The game starts from the K-th child, who tells all the others the integer on his card and jumps out of the circle. The integer on his card tells the next child to jump out. Let A denote the integer. If A is positive, the next child will be the A-th child to the left. If A is negative, the next child will be the (−A)-th child to the right.

The game lasts until all children have jumped out of the circle. During the game, the p-th child jumping out will get F(p) candies where F(p) is the number of positive integers that perfectly divide p. Who gets the most candies?

Input

There are several test cases in the input. Each test case starts with two integers N (0 < N ≤ 500,000) and K (1 ≤ K ≤ N) on the first line. The next N lines contains the names of the children (consisting of at most 10 letters) and the integers (non-zero with magnitudes within 108) on their cards in increasing order of the children’s numbers, a name and an integer separated by a single space in a line with no leading or trailing spaces.

Output

Output one line for each test case containing the name of the luckiest child and the number of candies he/she gets. If ties occur, always choose the child who jumps out of the circle first.

Sample Input

4 2
Tom 2
Jack 4
Mary -1
Sam 1

Sample Output

Sam 3

Source

POJ Monthly--2006.07.30, Sempr

题意

 n个孩子按顺时针排列,每个人手上都有一张牌,牌上有一个数字,从第k个孩子开始出队,出队的孩子卡上数字是val,则从他开始顺时针第val人是下一个出队的,负数则逆时针数那个第val个人,第P个出队的会得到的糖果数是p的因子个数,输出得到最多糖果的人和他的糖果数,如果有多个,则输出最先出队的人。

思路

先打表求出1-500000的因子个数,然后使用线段树,点修改,区间信息为这个区间还剩下多少人。

C++代码

#include<iostream>using namespace std;#define ls l,m,rt<<1
#define rs m+1,r,rt<<1|1const int N=500050;char name[N][15];
int val[N];
int f[N];//f[i]=j,表示数i有j个因子 
int sum[N<<2];//打表求f[n] 
void maketable(int n)
{for(int i=1;i<n;i++) f[i]=1;for(int i=2;i<n;i++)for(int j=i;j<n;j+=i)f[j]++;
}int getorder(int n)
{int k=1;for(int i=2;i<=n;i++)if(f[k]<f[i])k=i;return k;
}void pushup(int rt)
{sum[rt]=sum[rt<<1]+sum[rt<<1|1];
}void build(int l,int r,int rt)
{if(l==r){sum[rt]=1;return;}int m=(l+r)>>1;build(ls);build(rs);pushup(rt);
}int update(int num,int l,int r,int rt)
{if(l==r){sum[rt]=0;return l;}int m=(l+r)>>1;int res;if(num<=sum[rt<<1])res=update(num,ls);elseres=update(num-sum[rt<<1],rs);pushup(rt);return res;
}int main()
{int n,k;maketable(N);while(~scanf("%d%d",&n,&k)){for(int i=1;i<=n;i++)scanf("%s%d",name[i],&val[i]);build(1,n,1);int order=getorder(n);//出队次序为 order 的人获得的糖果最多 int pos=0,num=k,total=n,ln=0,rn=0;for(int i=1;i<=order;i++){pos=update(num,1,n,1);total--;ln=num-1;//删除元素左边的人的数量 rn=total-num+1;//删除元素右边的人的数量if(i==order) break;//找到第order个出队的人,跳出//获取下一个出队的人是现在队列中的第num个人,即求num int v=val[pos];//v表示跳跃值 if(v>0){v%=total;if(!v) v=total;if(v<=rn)num=ln+v;elsenum=v-rn;} else{v=-v;v%=total;if(!v) v=total;if(v<=ln)num=ln-v+1;elsenum=total-v+ln+1;}}printf("%s %d\n",name[pos],f[order]); }return 0;
}

 

这篇关于POJ2886 Who Gets the Most Candies?【线段树 点修改】的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/626332

相关文章

poj3468(线段树成段更新模板题)

题意:包括两个操作:1、将[a.b]上的数字加上v;2、查询区间[a,b]上的和 下面的介绍是下解题思路: 首先介绍  lazy-tag思想:用一个变量记录每一个线段树节点的变化值,当这部分线段的一致性被破坏我们就将这个变化值传递给子区间,大大增加了线段树的效率。 比如现在需要对[a,b]区间值进行加c操作,那么就从根节点[1,n]开始调用update函数进行操作,如果刚好执行到一个子节点,

hdu1394(线段树点更新的应用)

题意:求一个序列经过一定的操作得到的序列的最小逆序数 这题会用到逆序数的一个性质,在0到n-1这些数字组成的乱序排列,将第一个数字A移到最后一位,得到的逆序数为res-a+(n-a-1) 知道上面的知识点后,可以用暴力来解 代码如下: #include<iostream>#include<algorithm>#include<cstring>#include<stack>#in

hdu1689(线段树成段更新)

两种操作:1、set区间[a,b]上数字为v;2、查询[ 1 , n ]上的sum 代码如下: #include<iostream>#include<algorithm>#include<cstring>#include<stack>#include<queue>#include<set>#include<map>#include<stdio.h>#include<stdl

hdu 1754 I Hate It(线段树,单点更新,区间最值)

题意是求一个线段中的最大数。 线段树的模板题,试用了一下交大的模板。效率有点略低。 代码: #include <stdio.h>#include <string.h>#define TREE_SIZE (1 << (20))//const int TREE_SIZE = 200000 + 10;int max(int a, int b){return a > b ? a :

hdu 1166 敌兵布阵(树状数组 or 线段树)

题意是求一个线段的和,在线段上可以进行加减的修改。 树状数组的模板题。 代码: #include <stdio.h>#include <string.h>const int maxn = 50000 + 1;int c[maxn];int n;int lowbit(int x){return x & -x;}void add(int x, int num){while

poj 1127 线段相交的判定

题意: 有n根木棍,每根的端点坐标分别是 px, py, qx, qy。 判断每对木棍是否相连,当他们之间有公共点时,就认为他们相连。 并且通过相连的木棍相连的木棍也是相连的。 解析: 线段相交的判定。 首先,模板中的线段相交是不判端点的,所以要加一个端点在直线上的判定; 然后,端点在直线上的判定这个函数是不判定两个端点是同一个端点的情况的,所以要加是否端点相等的判断。 最后

HDU4737线段树

题目大意:给定一系列数,F(i,j)表示对从ai到aj连续求或运算,(i<=j)求F(i,j)<=m的总数。 const int Max_N = 100008 ;int sum[Max_N<<2] , x[Max_N] ;int n , m ;void push_up(int t){sum[t] = sum[t<<1] | sum[t<<1|1] ;}void upd

zoj 1721 判断2条线段(完全)相交

给出起点,终点,与一些障碍线段。 求起点到终点的最短路。 枚举2点的距离,然后最短路。 2点可达条件:没有线段与这2点所构成的线段(完全)相交。 const double eps = 1e-8 ;double add(double x , double y){if(fabs(x+y) < eps*(fabs(x) + fabs(y))) return 0 ;return x + y ;

圆与线段的交点

poj 3819  给出一条线段的两个端点,再给出n个圆,求出这条线段被所有圆覆盖的部分占了整条线段的百分比。 圆与线段的交点 : 向量AB 的参数方程  P = A + t * (B - A)      0<=t<=1 ; 将点带入圆的方程即可。  注意: 有交点 0 <= t <= 1 ; 此题求覆盖的部分。 则 若求得 t  满足 ; double ask(d

Codeforces 482B 线段树

求是否存在这样的n个数; m次操作,每次操作就是三个数 l ,r,val          a[l] & a[l+1] &......&a[r] = val 就是区间l---r上的与的值为val 。 也就是意味着区间[L , R] 每个数要执行 | val 操作  最后判断  a[l] & a[l+1] &......&a[r] 是否= val import ja